﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace codeit
{
    class gameVariables
    {
        public static int n;
        public static int[,] board;
        public static Stack<Point> move;
        public static bool FoundMove;
    }
    class Point
    {
        public int x,y;
        public Point()
        {
            this.x = -1;
            this.y = -1;
        }
        public Point(int x, int y)
        {
            this.x = x;
            this.y = y;
        }
    }
    class Program
    {
        static bool CheckField(int x, int y,bool special)
        {
            if (x < 0 || x >= gameVariables.n || y < 0 || y >= gameVariables.n) return false;
            if (special)
            {
                if (gameVariables.board[x, y] <= 0) return false;
            }
            else
            {
                if (gameVariables.board[x, y] != -1) return false;
            }
            for (int i = -1; i <= 1; i++)
            {
                for (int j = -1; j <= 1; j++)
                {
                    if ((Math.Abs(i) + Math.Abs(j))%2 == 0) continue;
                    if (x + i < 0 || x + i >= gameVariables.n || y + j < 0 || y + j >= gameVariables.n) continue;
                    if (gameVariables.board[x + i, y + j] == -2) return false;
                }
            }
            return true;
        }
        static void dfs(int x, int y,int remaining)
        {
            gameVariables.board[x, y] = -gameVariables.board[x,y]-100;
            gameVariables.move.Push(new Point(x,y));
            if (remaining == 0)
            {
                gameVariables.FoundMove = true;
                return;
            }
            if (CheckField(x + 1, y, false))
            {
                dfs(x + 1, y, remaining - 1);
                if (gameVariables.FoundMove) return;
            }
            if (CheckField(x - 1, y, false))
            {
                dfs(x - 1, y, remaining - 1);
                if (gameVariables.FoundMove) return;
            }
            if (CheckField(x, y + 1, false))
            {
                dfs(x , y + 1, remaining - 1);
                if (gameVariables.FoundMove) return;
            }
            if (CheckField(x, y - 1, false))
            {
                dfs(x , y - 1, remaining - 1);
                if (gameVariables.FoundMove) return;
            }
            gameVariables.move.Pop();
            gameVariables.board[x, y] = -gameVariables.board[x, y]-100;

        }
        static void Main(string[] args)
        {
            string input = File.ReadAllText("game.in");
            string[] lines= input.Split('\n');
            gameVariables.n = int.Parse(lines[0]);
            gameVariables.board = new int[gameVariables.n, gameVariables.n];
            for (int i = 1; i < lines.Length-1; i++)
            {
                string[] current = lines[i].Split(' ');
                for (int j = 0; j < gameVariables.n; j++)
                {
                    if (current[j] == "#") gameVariables.board[j, i - 1] = -1;
                    if (current[j] == "B") gameVariables.board[j, i -1] = -2;
                    if(current[j]!="B" && current[j]!="#") gameVariables.board[j, i - 1]=int.Parse(current[j]);
                }
            }
            for (int i = 0; i < gameVariables.n; i++)
            {
                for (int j = 0; j < gameVariables.n; j ++)
                {
                    if(!CheckField(i,j,true)) continue;
                    gameVariables.move = new Stack<Point>();
                    gameVariables.FoundMove = false;
                    dfs(i, j,gameVariables.board[i,j]-1);
                    if (gameVariables.FoundMove)
                    {
                        string output=gameVariables.move.Count+Environment.NewLine;
                        while (gameVariables.move.Count != 0)
                        {
                            Point current = gameVariables.move.Pop(); 
                            output += current.y + " " + current.x+Environment.NewLine;
                        }
                        File.WriteAllText("game.out", output);
                        Environment.Exit(0);
                    }
                }
            }
        }
    }
}
